math.randomseed (os.time ())

Music.playFile ("Resources/Frantic/Music.xm",true)

black = Color.new (0,0,0)
red = Color.new (255,0,0)
orange = Color.new (255,128,0)

fontscore = Font.load ("Resources/Frantic/Counter.ttf")
fontscore:setPixelSizes (40,40)

paddle1 = Sound.load ("Resources/Frantic/Paddle1.wav",false)
paddle2 = Sound.load ("Resources/Frantic/Paddle2.wav",false)

background = Image.load ("Resources/Frantic/Background.png")
P1Score = Image.load ("Resources/Frantic/P1Score.png")

CurrentSpeed = {pos = 2, neg = -2}

Ball = {x = 240, y = math.random (60,180), xspeed = CurrentSpeed.neg, yspeed = CurrentSpeed.pos, img = Image.load ("Resources/Frantic/Ball.png")}

Player = {}
Player[1] = {x = 2, y = 100, speed = 5, img = Image.load ("Resources/Frantic/P1Paddle.png")}
Player[2] = {x = 466, y = 100, speed = Ball.yspeed + 6, img = Image.load ("Resources/Frantic/P2Paddle.png")}

RecordFile = io.open ("Resources/Records/Frantic.txt","r")
Record = RecordFile:read ("*n")
RecordFile:close ()

Counter = Timer.new ()
Counter:start ()

CounterDisplay = Timer.new ()
CounterDisplay:start ()

Resolution = {width = 480, height = 272}

paddleSpot = math.random (Player[2].img:height ())

gamestate = "playing"

function drawImages ()
screen:blit (0,0,background)
screen:blit (Player[1].x,Player[1].y,Player[1].img)
screen:blit (Player[2].x,Player[2].y,Player[2].img)
screen:blit (Ball.x,Ball.y,Ball.img)
end

function drawScore ()
Display = CounterDisplay:time () / 1000

screen:fontPrint (fontscore,200,30,Display,orange)
screen:print (200,30,"Record: "..Record,black)
end

function speedAdvance ()
CounterTime = Counter:time () / 1000

if CounterTime > 20 then
	CurrentSpeed.pos = CurrentSpeed.pos + 1
	CurrentSpeed.neg = CurrentSpeed.neg - 1
	Player[1].speed = Player[1].speed + 0.2
	Counter:reset ()
	end
end

function ballMovement ()
if Ball.y <= 0 then
	Ball.yspeed = CurrentSpeed.pos
	end

if Ball.y + Ball.img:height () > Resolution.height then
	Ball.yspeed = CurrentSpeed.neg
	end

Ball.x = Ball.x + Ball.xspeed
Ball.y = Ball.y + Ball.yspeed
end

function checkCollision (obj1,obj2)
if (obj1.x + obj1.img:width () > obj2.x) and (obj1.x < obj2.x + obj2.img:width ()) and (obj1.y + obj1.img:height () > obj2.y) and (obj1.y < obj2.y + obj2.img:height ()) then

	if (obj1.y > obj2.y) and obj1.y < (obj2.y + obj2.img:height () / 2) then
		obj1.yspeed = CurrentSpeed.pos
		local sound = paddle2
		voice = sound:play ()
	
	else
		obj1.yspeed = CurrentSpeed.neg
		local sound = paddle1
		voice = sound:play ()
		end

if obj2 == Player[1] then
	obj1.xspeed = CurrentSpeed.pos
	
	else
		obj1.xspeed = CurrentSpeed.neg
	end
	end
end

function playerMovement ()
if pad:up () and Player[1].y > 0 then
	Player[1].y = Player[1].y - Player[1].speed
	end

if pad:down () and Player[1].y < (Resolution.height - Player[1].img:height ()) then
	Player[1].y = Player[1].y + Player[1].speed
	end

if pad:start () then 
	gamestate = "paused"
	end
	
if pad:select () then
	Music.stop ()
	dofile "Resources/menu.lua"
	end
end

function checkScore ()
if Ball.x < 0 - Ball.img:width () then
	if Display > Record then
		RecordFile = io.open ("Resources/Records/Frantic.txt","w")
		RecordFile:write (Record)
		RecordFile:close ()
		end
		
	dofile "Resources/franticp2.lua"
	end
	
if Ball.x > Resolution.width then
	gamestate = "scored"
	end
end

function hasScored ()
screen:blit (1,100,P1Score)

if pad:cross () then
	dofile "Resources/franticp1.lua"
	end
end

function cpuAI ()
if Ball.xspeed == CurrentSpeed.pos then
	if Player[2].y + paddleSpot < Ball.y and Player[2].y < (Resolution.height - Player[2].img:height ()) then
		Player[2].y = Player[2].y + Player[2].speed
		paddleSpot = math.random (Player[2].img:height ())
		end

		if Player[2].y + paddleSpot > Ball.y and Player[2].y > 0 then
			Player[2].y = Player[2].y - Player[2].speed
			paddleSpot = math.random (Player[2].img:height ())
			end
	end
end


function paused ()
button = System.buttonPressed (0)

System.message ("Paused",0)

if button == button then

	gamestate = "playing"
	end
end

function gameFunctions ()
drawImages ()
drawScore ()

if gamestate == "playing" then
	Counter:start ()
	speedAdvance () 
	playerMovement ()
	ballMovement ()
	cpuAI ()
	checkCollision (Ball,Player[1])
	checkCollision (Ball,Player[2])
	checkScore ()
	end

if gamestate == "scored" then
	hasScored ()
	end
	
if gamestate == "paused" then
	Counter:stop ()
	paused ()
	end
end	
	
while true do
pad = Controls.read ()
screen:clear ()

gameFunctions ()

screen.waitVblankStart ()
screen.flip ()
end