math.randomseed(os.time ())

Music.playFile ("Resources/PongQ-Mark/Music.xm")

black = Color.new (0,0,0)
grey = Color.new (128,128,128)
lime = Color.new (153,204,0)
red = Color.new (255,0,0)

paddle1 = Sound.load("Resources/PongQ-Mark/Paddle1.wav")
paddle2 = Sound.load("Resources/PongQ-Mark/Paddle2.wav")


background = Image.load ("Resources/PongQ-Mark/Background.png")
P1Score = Image.load ("Resources/PongQ-Mark/P1Score.png")
P2Score = Image.load ("Resources/PongQ-Mark/P2Score.png")

Player = {}
Player[1] = {x = 2, y = 100, speed = 4, score = 100, img = Image.load ("Resources/PongQ-Mark/P1Paddle.png")}
Player[2] = {x = 466, y = 100, speed = 6, score = 100, img = Image.load ("Resources/PongQ-Mark/P2Paddle.png")}

Ball = {x = 240, y = math.random (60,180), xspeed = -6.2, yspeed = 6, img = Image.load ("Resources/PongQ-Mark/Ball.png")}

Healthbar = {}
Healthbar[1] = {y = 10}
Healthbar[2] = {y = 10}

taunts = {"Did you get dropped on the head as a baby?", "It's called a paddle. USE IT.", "Congratulations! You just... Wait a minute you suck.", "And another one bites the dust.", "You just got owned.", "I'm barely even trying, geez.", "Maybe you want to try tic-tac-toe? I heard that's easy.", "Do you even know what 'Pong' is?", "Do you know how to play? ", "Your IQ = 5.", "Boy, I am good at this!", "You are losing to a computer. How sad.", "I don't think I'm the one with artificial intelligence.", "Did I tell you how sad you are?", "You have skills? What skills?", "Add Pong to the list of things you can't do.", "You smell bad.", "Computers rule and humans drool.", "I'm 1337.", "You = 0 for supremely bad.", "We can play all day and you would still suck.", "Just press SELECT and end it already.", "Ha! Did I tell you I was good, because I really am.", "Yup, that's definitely how you win the game.", "It's okay, we all know you aren't any good anyway.", "If you want I can go easy on you.", "Maybe you'd prefer a game with a difficulty level called 'DUMB?'", "Maybe you'd just prefer a game called 'For Dummies.'", "Nice try... NOT!", "Oh wow, I am the BOMB!", "AND YOU DIDN'T SCORE!", "You couldn't block that ball even if it were as big as your brain...wait, maybe you could.", "Go back and play pong.DINOSAUR!", "I'm so good I amaze even myself.", "Maybe I should enter a Pong tournament?"}

taunt = taunts[math.random (#taunts)]

runtaunt = 1

Resolution = {width = 480, height = 272}

whoScored = nil

paddleSpot = math.random (Player[2].img:height ())

gamestate = "playing"

function drawImages ()
screen:blit (0,0,background)
screen:blit (Player[1].x,Player[1].y,Player[1].img)
screen:blit (Player[2].x,Player[2].y,Player[2].img)
screen:blit (Ball.x,Ball.y,Ball.img)
end

function drawScore ()
screen:fillRect (109,11,100,11,grey)
screen:fillRect (261,11,100,11,grey)
screen:fillRect (108,10,100,10,red)
screen:fillRect (260,10,100,10,red)
screen:fillRect (108,10,Player[1].score,Healthbar[1].y,lime)
screen:fillRect (260,10,Player[2].score,Healthbar[2].y,lime)
end

function ballMovement ()
if Ball.y <= 0 then
	Ball.yspeed = 6
	end

if Ball.y + Ball.img:height () > Resolution.height then
	Ball.yspeed = -6
	end

Ball.x = Ball.x + Ball.xspeed
Ball.y = Ball.y + Ball.yspeed
end

function checkCollision (obj1,obj2)
if (obj1.x + obj1.img:width () > obj2.x) and (obj1.x < obj2.x + obj2.img:width ()) and (obj1.y + obj1.img:height () > obj2.y) and (obj1.y < obj2.y + obj2.img:height ()) then

	if (obj1.y > obj2.y) and obj1.y < (obj2.y + obj2.img:height () / 2) then
		obj1.yspeed = -6.2
		local sound = paddle2
		voice = sound:play ()
	
	else
		obj1.yspeed = 6.2
		local sound = paddle1
		voice = sound:play ()
		end

if obj2 == Player[1] then
	obj1.xspeed = 6.2
	
	else
		obj1.xspeed = -6.2
	end
	end
end

function playerMovement ()
if pad:up () and Player[1].y > 0 then
	Player[1].y = Player[1].y - Player[1].speed
	end

if pad:down () and Player[1].y < (Resolution.height - Player[1].img:height ()) then
	Player[1].y = Player[1].y + Player[1].speed
	end

if pad:start () then 
	gamestate = "paused"
	end
	
if pad:select () then
	Music.stop ()
	dofile "Resources/menu.lua"
	end
end

function checkScore ()
if Ball.x < 0 - Ball.img:width () then
	gamestate = "scored"
	Player[1].score = Player[1].score - 10

	if Player[2].score < 100 then
		Player[2].score = Player[2].score + 10
		end 

whoScored = "CPU"
Ball.x = 240
Ball.y = math.random (80,120)
Ball.xspeed = 6.2
	end

if Ball.x > Resolution.width then
	gamestate = "scored"
	Player[2].score = Player[2].score - 10

	if Player[1].score < 100 then
		Player[1].score = Player[1].score + 10
		end

whoScored = "You"
Ball.x = 240
Ball.y = math.random (80,120)
Ball.xspeed = -6
	end
end

function hasScored ()
randomAI = math.random (1,2)

if randomAI == 1 then
	Player[2].speed = 6
	
		elseif randomAI == 2 then
			Player[2].speed = 5.5
	end

if Player[2].score == 0 then
	Music.stop ()
	dofile "Resources/pongp1.lua"
	
		elseif Player[1].score == 0 then
			Music.stop ()
			dofile "Resources/pongp2.lua"
	
			elseif whoScored == "CPU" then
				if runtaunt == 1 then
					taunt = taunts[math.random(#taunts)]
					runtaunt = 0
					end
					
				screen:blit (0,100,P2Score)
				screen:print (10,190,taunt,black)
	
	else
		screen:blit (0,100,P1Score)
	end

if pad:cross () then
	runtaunt = 1
	gamestate = "playing"
	end
	end

function cpuAI ()
if Ball.xspeed == 6.2 then
	if Player[2].y + paddleSpot < Ball.y and Player[2].y < (Resolution.height - Player[2].img:height ()) then
		Player[2].y = Player[2].y + Player[2].speed
		paddleSpot = math.random (Player[2].img:height ())
		end

	if Player[2].y + paddleSpot > Ball.y and Player[2].y > 0 then
		Player[2].y = Player[2].y - Player[2].speed
		paddleSpot = math.random (Player[2].img:height ())
		end
	end
	end

function paused ()
button = System.buttonPressed (0)

System.message ("Paused",0)

if button == button then

	gamestate = "playing"
	end
end

function gameFunctions ()
drawImages ()
drawScore ()

if gamestate == "playing" then
	playerMovement ()
	ballMovement ()
	cpuAI ()
	checkCollision (Ball,Player[1])
	checkCollision (Ball,Player[2])
	checkScore ()
	end

if gamestate == "paused" then
	paused ()
	end

if gamestate == "scored" then
	hasScored ()
	end
	end	
	
while true do
pad = Controls.read ()
screen:clear ()

gameFunctions ()

screen.waitVblankStart ()
screen.flip ()
end 
