math.randomseed (os.time ())

--Music disabled for pong.DINOSAUR due to crashing issues. To be restored with the Lua HM compatible version.
--Music.playFile ("Resources/pong.DINOSAUR/Music.xm",true)

black = Color.new (0,0,0)
white = Color.new (255,255,255)

fontscore = Font.load ("Resources/pong.DINOSAUR/Score.ttf")
fontscore:setPixelSizes (25,48)

paddle1 = Sound.load ("Resources/pong.DINOSAUR/Paddle1.wav",false)
paddle2 = Sound.load ("Resources/pong.DINOSAUR/Paddle2.wav",false)

background = Image.load ("Resources/pong.DINOSAUR/Background.png")

Player = {}
Player[1] = {x = 2, y = 100, speed = 4, score = 0, img = Image.load ("Resources/pong.DINOSAUR/P1Paddle.png")}
Player[2] = {x = 466, y = 100, speed = 4.2, score = 0, img = Image.load ("Resources/pong.DINOSAUR/P2Paddle.png")}

Ball = {x = 240, y = math.random (60,180), xspeed = -3, yspeed = 3, img = Image.load ("Resources/pong.DINOSAUR/Ball.png")}

Resolution = {width = 480, height = 272}

whoScored = nil

paddleSpot = math.random (Player[2].img:height ())

gamestate = "playing"

function drawImages ()
screen:blit (0,0,background)
screen:blit (Player[1].x,Player[1].y,Player[1].img)
screen:blit (Player[2].x,Player[2].y,Player[2].img)
screen:blit (Ball.x,Ball.y,Ball.img)
end

function drawScore ()
screen:fontPrint (fontscore,170,50,Player[1].score,white)
screen:fontPrint (fontscore,280,50,Player[2].score,white)
end

function ballMovement ()
if Ball.y <= 0 then
	Ball.yspeed = 3
end

if Ball.y + Ball.img:height () > Resolution.height then
	Ball.yspeed = -3
end

Ball.x = Ball.x + Ball.xspeed
Ball.y = Ball.y + Ball.yspeed
end

function checkCollision (obj1,obj2)
if (obj1.x + obj1.img:width () > obj2.x) and (obj1.x < obj2.x + obj2.img:width ()) and (obj1.y + obj1.img:height () > obj2.y) and (obj1.y < obj2.y + obj2.img:height ()) then

	if (obj1.y > obj2.y) and obj1.y < (obj2.y + obj2.img:height () / 2) then
	obj1.yspeed = -3
	local sound = paddle2
	voice = sound:play ()
	
		else
		obj1.yspeed = 3
		local sound = paddle1
		voice = sound:play ()
		end

	if obj2 == Player[1] then
	obj1.xspeed = 3
	
		else
		obj1.xspeed = -3
		end
end
end

function playerMovement ()
if pad:up () and Player[1].y > 0 then
	Player[1].y = Player[1].y - Player[1].speed
end

if pad:down () and Player[1].y < (Resolution.height - Player[1].img:height ()) then
	Player[1].y = Player[1].y + Player[1].speed
end

if pad:start () then 
	gamestate = "paused"
end
end

function checkScore ()
if Ball.x < 0 - Ball.img:width () then
	Player[2].score = Player[2].score + 1

Ball.x = 240
Ball.y = math.random (80,120)
Ball.xspeed = 3
end

if Ball.x > Resolution.width then
	Player[1].score = Player[1].score + 1

Ball.x = 240
Ball.y = math.random (80,120)
Ball.xspeed = -3
end
end

function hasScored ()
if Player[1].score == 10 then
	Music.stop ()
	dofile "Resources/pongDINOSAURp1.lua"
	
		elseif Player[2].score == 10 then
		Music.stop ()
		dofile "Resources/pongDINOSAURp2.lua"
end

if pad:cross () then
	gamestate = "playing"
	end
end

function cpuAI ()
if Ball.xspeed == 3 and Ball.x > 240 then
	if Player[2].y + paddleSpot < Ball.y and Player[2].y < (Resolution.height - Player[2].img:height ()) then
	Player[2].y = Player[2].y + Player[2].speed
	paddleSpot = math.random (Player[2].img:height ())
		end

	if Player[2].y + paddleSpot > Ball.y and Player[2].y > 0 then
	Player[2].y = Player[2].y - Player[2].speed
	paddleSpot = math.random (Player[2].img:height ())
		end
	end
end

function paused ()
button = System.buttonPressed (0)

System.message ("Paused",0)

if button == button then

	gamestate = "playing"
	end
end

function gameFunctions ()
drawImages ()
drawScore ()

if gamestate == "playing" then
	playerMovement ()
	ballMovement ()
	cpuAI ()
	checkCollision (Ball,Player[1])
	checkCollision (Ball,Player[2])
	checkScore ()
	hasScored ()
end

if gamestate == "paused" then
	paused ()
	end
	end

while true do
pad = Controls.read ()
screen:clear ()

gameFunctions ()

screen.waitVblankStart ()
screen.flip ()

if pad:select () then
	Music.stop ()
	dofile "Resources/menu.lua"
	end
end 